 
transcript on
quit -sim
if {[file exists gate_work]} {
	vdel -lib gate_work -all
}

vlib gate_work
vmap work gate_work


vcom -93 -work work {rx.vhd}
vcom -93 -work work {reco.vhd}
vcom -93 -work work {simulation/modelsim/StratixIV_Tx_4_900mv_85c_slow.vho}
vcom -93 -work work {tbTxSDO_withReset.vhd}

vsim -t 1ps +transport_int_delays +transport_path_delays -sdftyp /tx_inst=simulation/modelsim/StratixIV_Tx_4_900mv_85c_vhd_slow.sdo -L altera_mf -L altera -L lpm -L sgate -L stratixiv_hssi -L stratixiv_pcie_hip -L stratixiv -L gate_work -L work -voptargs="+acc" tbTxSDO_withReset

view wave
delete wave *

add wave -noupdate -divider Transmitter 
add wave -noupdate \
{sim:/tbTxSDO_withReset/master_clock0 } \
{sim:/tbTxSDO_withReset/tx_pll_inclk_1 } \
{sim:/tbTxSDO_withReset/tx_cal_blk_clk_1 } \
{sim:/tbTxSDO_withReset/tx_pll_inclk_2 } \
{sim:/tbTxSDO_withReset/tx_cal_blk_clk_2 } \
{sim:/tbTxSDO_withReset/vme_addr } 


add wave -noupdate -divider TxDataIn
add wave -noupdate -radix hexadecimal  \
{sim:/tbTxSDO_withReset/datain0 } \
{sim:/tbTxSDO_withReset/datain1 } \
{sim:/tbTxSDO_withReset/datain2 } \
{sim:/tbTxSDO_withReset/datain3 } \
{sim:/tbTxSDO_withReset/datain4 } \
{sim:/tbTxSDO_withReset/datain5 } 


add wave -noupdate -divider Receiver 
add wave -noupdate \
{sim:/tbTxSDO_withReset/cal_blk_clk } \
{sim:/tbTxSDO_withReset/reconfig_clk } \
{sim:/tbTxSDO_withReset/rx_analogreset } \
{sim:/tbTxSDO_withReset/rx_digitalreset } \
{sim:/tbTxSDO_withReset/rx_clkout } \
{sim:/tbTxSDO_withReset/rx_pll_locked } \
{sim:/tbTxSDO_withReset/rx_freqlocked } \
{sim:/tbTxSDO_withReset/rx_syncstatus } \
{sim:/tbTxSDO_withReset/rx_byteorderalignstatus } \
{sim:/tbTxSDO_withReset/rx_patterndetect } \
{sim:/tbTxSDO_withReset/rx_errdetect } \
{sim:/tbTxSDO_withReset/rx_ctrldetect }

add wave -noupdate -radix hexadecimal {sim:/tbTxSDO_withReset/rx_dataout } 

add wave -radix hexadecimal \
{sim:/tbTxSDO_withReset/rx_group1 } \
{sim:/tbTxSDO_withReset/rx_group2 } \
{sim:/tbTxSDO_withReset/rx_group3 } \
{sim:/tbTxSDO_withReset/rx_group4 } \
{sim:/tbTxSDO_withReset/rx_group5 } \
{sim:/tbTxSDO_withReset/rx_group6 } 


# clocks
force -freeze sim:/tbTxSDO_withReset/master_clock0 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/cal_blk_clk 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/reconfig_clk 0 0ns, 1 10ns -repeat 20ns
force -freeze sim:/tbTxSDO_withReset/tx_pll_inclk_1 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/tx_pll_inclk_2 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/tx_cal_blk_clk_1 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/tx_cal_blk_clk_2 0 0ns, 1 5ns -repeat 10ns

force -freeze sim:/tbTxSDO_withReset/in_clk0 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/in_clk1 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/in_clk2 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/in_clk3 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/in_clk4 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/tbTxSDO_withReset/in_clk5 0 0ns, 1 5ns -repeat 10ns

# vme_addr setting:
#force -freeze sim:/tbTxSDO_withReset/vme_addr  16#0180000 0ns, 16#0080000 20ns, 16#00BFFFC 1200ns, 16#0080000 1220ns, 16#0000000 1350ns
force -freeze sim:/tbTxSDO_withReset/vme_addr  16#0060000 0ns, 16#0020000 20ns, 16#002FFFF 1200ns, 16#0020000 1220ns, 16#0010000 1350ns

force -freeze sim:/tbTxSDO_withReset/rx_analogreset 16#FFFF 0ns, 16#0000 500ns
force -freeze sim:/tbTxSDO_withReset/rx_digitalreset 16#FFFF 0ns, 16#0000 1000ns

# input data

force -freeze sim:/tbTxSDO_withReset/datain0 16#0000011 0ns, 16#FB0FFB0 1200ns, 16#EADDEAD 1300ns, 16#EEFBEEF 1400ns, 16#EEDFEED 1500ns, 16#ACEFACE 1600ns
force -freeze sim:/tbTxSDO_withReset/datain1 16#0000022 0ns, 16#CA0CCA0 1200ns, 16#DAAAAAD 1300ns, 16#D18D0DD 1400ns, 16#CABEEFE 1500ns, 16#DACEBBB 1600ns
force -freeze sim:/tbTxSDO_withReset/datain2 16#0000033 0ns, 16#BDEBDEE 1200ns, 16#CBBBBBD 1300ns, 16#FACBBAE 1400ns, 16#DEEFE80 1500ns, 16#DEEFACE 1600ns
force -freeze sim:/tbTxSDO_withReset/datain3 16#0000044 0ns, 16#BACBBAC 1200ns, 16#EADDEAD 1300ns, 16#EEFBEEF 1400ns, 16#EEDFEED 1500ns, 16#ACEFACE 1600ns
force -freeze sim:/tbTxSDO_withReset/datain4 16#0000055 0ns, 16#E01EE01 1200ns, 16#DAAAAAD 1300ns, 16#D18D0DD 1400ns, 16#A90B90D 1500ns, 16#DACEBBB 1600ns
force -freeze sim:/tbTxSDO_withReset/datain5 16#0000066 0ns, 16#AF8AAF8 1200ns, 16#CBBBBBE 1300ns, 16#FACBBCE 1400ns, 16#CEE88EE 1500ns, 16#DEEFACE 1600ns


configure wave -namecolwidth 200
run 2000ns	
view wave
update
WaveRestoreZoom {0 ps} {1820 ns}