LIBRARY ieee;
 USE ieee.std_logic_1164.all;
 
  ENTITY  tbTxReset IS 
	 PORT 
	 ( 
		-- for the 1st Tx
		cal_blk_clk_1		: IN STD_LOGIC ;
		pll_inclk_1		: IN STD_LOGIC ;
		-- pll_powerdown		: IN STD_LOGIC_VECTOR (0 DOWNTO 0); internal sig
		tx_ctrlenable_1		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		-- tx_digitalreset		: IN STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		--coreclkout		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
		-- pll_locked		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		--tx_dataout		: OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
		reset_tx_1		: in  std_logic;
		The_clk_1			: IN STD_LOGIC ;  -- clock for reset 
		
		data0_1		: IN STD_LOGIC_VECTOR (27 DOWNTO 0);		
		rdreq0_1		: IN STD_LOGIC ;
		wrclk0_1		: IN STD_LOGIC ;
		wrreq0_1		: IN STD_LOGIC ;
		 
		data1_1		: IN STD_LOGIC_VECTOR (27 DOWNTO 0);		
		rdreq1_1		: IN STD_LOGIC ;
		wrclk1_1		: IN STD_LOGIC ;
		wrreq1_1		: IN STD_LOGIC ;
		 
		data2_1		: IN STD_LOGIC_VECTOR (27 DOWNTO 0);		
		rdreq2_1		: IN STD_LOGIC ;
		wrclk2_1		: IN STD_LOGIC ;
		wrreq2_1		: IN STD_LOGIC ;
		
		clrrom_1       : IN STD_LOGIC;
		muxsel_1       : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
		
		-- for the 2nd Tx
		cal_blk_clk_2		: IN STD_LOGIC ;
		pll_inclk_2		: IN STD_LOGIC ;
		-- pll_powerdown		: IN STD_LOGIC_VECTOR (0 DOWNTO 0); internal sig
		tx_ctrlenable_2		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		-- tx_digitalreset		: IN STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		--coreclkout		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
		-- pll_locked		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		--tx_dataout		: OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
		reset_tx_2		: in  std_logic;
		The_clk_2			: IN STD_LOGIC ;  -- clock for reset 
		
		data0_2		: IN STD_LOGIC_VECTOR (27 DOWNTO 0);		
		rdreq0_2		: IN STD_LOGIC ;
		wrclk0_2		: IN STD_LOGIC ;
		wrreq0_2		: IN STD_LOGIC ;
		 
		data1_2		: IN STD_LOGIC_VECTOR (27 DOWNTO 0);		
		rdreq1_2		: IN STD_LOGIC ;
		wrclk1_2		: IN STD_LOGIC ;
		wrreq1_2		: IN STD_LOGIC ;
		 
		data2_2		: IN STD_LOGIC_VECTOR (27 DOWNTO 0);		
		rdreq2_2		: IN STD_LOGIC ;
		wrclk2_2		: IN STD_LOGIC ;
		wrreq2_2		: IN STD_LOGIC ;
		
		clrrom_2       : IN STD_LOGIC;
		muxsel_2       : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
		
		-- for Rx
		cal_blk_clk  		: IN STD_LOGIC ;
		reconfig_clk		: IN STD_LOGIC ;
		rx_byteorderalignstatus		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_analogreset		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_digitalreset		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_pll_locked		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_clkout		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_ctrldetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_dataout		: OUT STD_LOGIC_VECTOR (255 DOWNTO 0);
		rx_errdetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_freqlocked		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_patterndetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_syncstatus		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
	 ); 
 END tbTxReset;
 
ARCHITECTURE RTL OF tbTxReset IS

component TxBlock
	PORT
	(
		cal_blk_clk		: IN STD_LOGIC ;
		pll_inclk		: IN STD_LOGIC ;
		-- pll_powerdown		: IN STD_LOGIC_VECTOR (0 DOWNTO 0); internal sig
		tx_ctrlenable		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		-- tx_digitalreset		: IN STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		--coreclkout		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
		-- pll_locked		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		tx_dataout		: OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
		reset_tx		: in  std_logic;
		The_clk			: IN STD_LOGIC ;  -- clock for reset 
		
		data0		: IN STD_LOGIC_VECTOR (27 DOWNTO 0);		
		rdreq0		: IN STD_LOGIC ;
		wrclk0		: IN STD_LOGIC ;
		wrreq0		: IN STD_LOGIC ;
		 
		data1		: IN STD_LOGIC_VECTOR (27 DOWNTO 0);		
		rdreq1		: IN STD_LOGIC ;
		wrclk1		: IN STD_LOGIC ;
		wrreq1		: IN STD_LOGIC ;
		 
		data2		: IN STD_LOGIC_VECTOR (27 DOWNTO 0);		
		rdreq2		: IN STD_LOGIC ;
		wrclk2		: IN STD_LOGIC ;
		wrreq2		: IN STD_LOGIC ;
		
		clrrom       : IN STD_LOGIC;
		muxsel       : IN STD_LOGIC_VECTOR (1 DOWNTO 0)
		
	);
end component;

component reco
	PORT
		(
		reconfig_clk		: IN STD_LOGIC ;
		reconfig_fromgxb		: IN STD_LOGIC_VECTOR (67 DOWNTO 0);
		busy		: OUT STD_LOGIC ;
		reconfig_togxb		: OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
	);
end component;

component rx
	PORT
	(
		cal_blk_clk		: IN STD_LOGIC ;
		reconfig_clk		: IN STD_LOGIC ;
		reconfig_togxb		: IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		rx_analogreset		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_cruclk		: IN STD_LOGIC_VECTOR (15 DOWNTO 0) :=  (OTHERS => '0');
		rx_datain		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_digitalreset		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		reconfig_fromgxb		: OUT STD_LOGIC_VECTOR (67 DOWNTO 0);
		rx_byteorderalignstatus		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_clkout		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_ctrldetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_dataout		: OUT STD_LOGIC_VECTOR (255 DOWNTO 0);
		rx_errdetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_freqlocked		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_patterndetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_pll_locked		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_syncstatus		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
	);
	 
end component;

-- serial wire
signal datainout : std_logic_vector(15 downto 0);

-- signals to reconfig block
signal reconfig_fromgxb_sig		: STD_LOGIC_VECTOR (67 DOWNTO 0);
signal busy_sig : STD_LOGIC;
signal reconfig_togxb_sig : STD_LOGIC_VECTOR (3 DOWNTO 0);

-- rx clock 
signal pll_cru_clk_sig: STD_LOGIC_VECTOR (15 DOWNTO 0); 

-- tmp signals to monitor output
signal rx_dataout_sig : std_logic_vector(255 downto 0);

signal rx_group1 : std_logic_vector(27 downto 0);
signal rx_group2 : std_logic_vector(27 downto 0);
signal rx_group3 : std_logic_vector(27 downto 0);
signal rx_group4 : std_logic_vector(27 downto 0);
signal rx_group5 : std_logic_vector(27 downto 0);
signal rx_group6 : std_logic_vector(27 downto 0);

BEGIN

rx_dataout <= rx_dataout_sig;

rx_group1 <= rx_dataout_sig(27 downto 0);
rx_group2 <= rx_dataout_sig(55 downto 28);
rx_group3 <= rx_dataout_sig(83 downto 56);

rx_group4 <= rx_dataout_sig(155 downto 128);
rx_group5 <= rx_dataout_sig(183 downto 156);
rx_group6 <= rx_dataout_sig(211 downto 184);

label1: for ii in 0 to 15 generate
  pll_cru_clk_sig(ii) <= cal_blk_clk;
end generate;
 
 
-- tx 2 copies
	tx_inst1 : TxBlock PORT MAP (
		cal_blk_clk		=>  cal_blk_clk_1,
		pll_inclk		=>  pll_inclk_1,
		-- pll_powerdown		: IN STD_LOGIC_VECTOR (0 DOWNTO 0); internal sig
		tx_ctrlenable	=>  tx_ctrlenable_1,	
		-- tx_digitalreset		: IN STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		--coreclkout		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
		-- pll_locked		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		tx_dataout		=>  datainout( 7 downto 0),
		reset_tx		=>  reset_tx_1,
		The_clk			=>  The_clk_1,
		
		data0		=>  data0_1,
		rdreq0		=>  rdreq0_1,
		wrclk0		=>  wrclk0_1,
		wrreq0		=>  wrreq0_1,
		 
		data1		=>  data1_1,	
		rdreq1		=>  rdreq1_1,
		wrclk1		=>  wrclk1_1,
		wrreq1		=>  wrreq1_1,
		 
		data2		=>  data2_1,		
		rdreq2		=>  rdreq2_1,
		wrclk2		=>  wrclk2_1,
		wrreq2		=>  wrreq2_1,
		
		clrrom      =>  clrrom_1, 
		muxsel      =>   muxsel_1
	);
	
	tx_inst2 : TxBlock PORT MAP (
		cal_blk_clk		=>  cal_blk_clk_2,
		pll_inclk		=>  pll_inclk_2,
		-- pll_powerdown		: IN STD_LOGIC_VECTOR (0 DOWNTO 0); internal sig
		tx_ctrlenable	=>  tx_ctrlenable_2,	
		-- tx_digitalreset		: IN STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		--coreclkout		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);
		-- pll_locked		: OUT STD_LOGIC_VECTOR (0 DOWNTO 0);  internal sig
		tx_dataout		=>  datainout( 15 downto 8),
		reset_tx		=>  reset_tx_2,
		The_clk			=>  The_clk_2,
		
		data0		=>  data0_2,
		rdreq0		=>  rdreq0_2,
		wrclk0		=>  wrclk0_2,
		wrreq0		=>  wrreq0_2,
		 
		data1		=>  data1_2,	
		rdreq1		=>  rdreq1_2,
		wrclk1		=>  wrclk1_2,
		wrreq1		=>  wrreq1_2,
		 
		data2		=>  data2_2,		
		rdreq2		=>  rdreq2_2,
		wrclk2		=>  wrclk2_2,
		wrreq2		=>  wrreq2_2,
		
		clrrom      =>  clrrom_2, 
		muxsel      =>   muxsel_2
	);

-- reconfig
	reco_inst : reco PORT MAP (
		reconfig_clk	 => reconfig_clk,
		reconfig_fromgxb	 => reconfig_fromgxb_sig,
		busy	 => busy_sig,
		reconfig_togxb	 => reconfig_togxb_sig
	);

-- rx
	rx_inst : rx PORT MAP (
		cal_blk_clk	 => cal_blk_clk,
		rx_cruclk		 => pll_cru_clk_sig,
		reconfig_clk	 => reconfig_clk,
		reconfig_togxb	 => reconfig_togxb_sig,
		rx_analogreset	 => rx_analogreset,
		rx_datain	 => datainout,
		rx_digitalreset	 => rx_digitalreset,
		rx_pll_locked	 => rx_pll_locked,
		reconfig_fromgxb	 => reconfig_fromgxb_sig,
		rx_byteorderalignstatus => rx_byteorderalignstatus,
		rx_clkout	 => rx_clkout,
		rx_ctrldetect	 => rx_ctrldetect,
		rx_dataout	 => rx_dataout_sig,
		rx_errdetect	 => rx_errdetect,
		rx_freqlocked	 => rx_freqlocked,
		rx_patterndetect	 => rx_patterndetect,
		rx_syncstatus	 => rx_syncstatus
	);

END RTL;
