LIBRARY ieee;
 USE ieee.std_logic_1164.all;
 
  ENTITY  tbTxSDO_withReset IS 
	 PORT 
	 ( 
		-- The transmitter block
		master_clock0		:	 IN STD_LOGIC;
		vme_as		:	 IN STD_LOGIC;
		vme_ds		:	 IN STD_LOGIC;
		vme_addr			:	 IN STD_LOGIC_VECTOR(26 DOWNTO 2);
		vme_write_read		:	 IN STD_LOGIC;
		tx_pll_inclk_1		:	 IN STD_LOGIC;
		tx_cal_blk_clk_1	:	 IN STD_LOGIC;
		tx_pll_inclk_2		:	 IN STD_LOGIC;
		tx_cal_blk_clk_2		:	 IN STD_LOGIC;
		USB_CLKOUT		:	 IN STD_LOGIC;
		datain0		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk0		:	 IN STD_LOGIC;
		datain1		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk1		:	 IN STD_LOGIC;
		datain2		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk2		:	 IN STD_LOGIC;
		datain3		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk3		:	 IN STD_LOGIC;
		datain4		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk4		:	 IN STD_LOGIC;
		datain5		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk5		:	 IN STD_LOGIC;
		dir_trans		:	 OUT STD_LOGIC;
		transceivers_OE		:	 OUT STD_LOGIC;
		--two_dataout		:	 OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		--one_dataout		:	 OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		vme_data		:	 INOUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		debug		:	 INOUT STD_LOGIC_VECTOR(19 DOWNTO 2);
		InternalAUX		:	 INOUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		HOLDin		:	 INOUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		USB_SPARE		:	 INOUT STD_LOGIC;
		USB_PA		:	 INOUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		USB_CTL		:	 INOUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		USB_RDY		:	 INOUT STD_LOGIC_VECTOR(1 DOWNTO 0);
		USB_IFCLK		:	 INOUT STD_LOGIC;
		USB_FD		:	 INOUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		HOLDtoEDRO		:	 INOUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		LED_1		:	 INOUT STD_LOGIC;
		LED_2		:	 INOUT STD_LOGIC;
		LED_3		:	 INOUT STD_LOGIC;
		FREEZEout		:	 INOUT STD_LOGIC;
		FREEZEin		:	 INOUT STD_LOGIC;
		USB_WAKEUP		:	 INOUT STD_LOGIC;
		
		-- for Rx
		cal_blk_clk  		: IN STD_LOGIC ;
		reconfig_clk		: IN STD_LOGIC ;
		rx_byteorderalignstatus		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_analogreset		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_digitalreset		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_pll_locked		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_clkout		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_ctrldetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_dataout		: OUT STD_LOGIC_VECTOR (255 DOWNTO 0);
		rx_errdetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_freqlocked		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_patterndetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_syncstatus		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
	 ); 
 END tbTxSDO_withReset;
 
ARCHITECTURE RTL OF tbTxSDO_withReset IS

COMPONENT StratixIV_Tx
	PORT
	(
		master_clock0		:	 IN STD_LOGIC;
		vme_as		:	 IN STD_LOGIC;
		vme_ds		:	 IN STD_LOGIC;
		vme_addr		:	 IN STD_LOGIC_VECTOR(26 DOWNTO 2);
		vme_write_read		:	 IN STD_LOGIC;
		clkin1		:	 IN STD_LOGIC;
		clkin2		:	 IN STD_LOGIC;
		clkin3		:	 IN STD_LOGIC;
		clkin4		:	 IN STD_LOGIC;
		USB_CLKOUT		:	 IN STD_LOGIC;
		in0		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk0		:	 IN STD_LOGIC;
		in1		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk1		:	 IN STD_LOGIC;
		in2		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk2		:	 IN STD_LOGIC;
		in3		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk3		:	 IN STD_LOGIC;
		in4		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk4		:	 IN STD_LOGIC;
		in5		:	 IN STD_LOGIC_VECTOR(27 DOWNTO 0);
		in_clk5		:	 IN STD_LOGIC;
		dir_trans		:	 OUT STD_LOGIC;
		transceivers_OE		:	 OUT STD_LOGIC;
		two_dataout		:	 OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		one_dataout		:	 OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		vme_data		:	 INOUT STD_LOGIC_VECTOR(31 DOWNTO 0);
		debug		:	 INOUT STD_LOGIC_VECTOR(19 DOWNTO 2);
		InternalAUX		:	 INOUT STD_LOGIC_VECTOR(17 DOWNTO 0);
		HOLDin		:	 INOUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		USB_SPARE		:	 INOUT STD_LOGIC;
		USB_PA		:	 INOUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		USB_CTL		:	 INOUT STD_LOGIC_VECTOR(2 DOWNTO 0);
		USB_RDY		:	 INOUT STD_LOGIC_VECTOR(1 DOWNTO 0);
		USB_IFCLK		:	 INOUT STD_LOGIC;
		USB_FD		:	 INOUT STD_LOGIC_VECTOR(15 DOWNTO 0);
		HOLDtoEDRO		:	 INOUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		LED_1		:	 INOUT STD_LOGIC;
		LED_2		:	 INOUT STD_LOGIC;
		LED_3		:	 INOUT STD_LOGIC;
		FREEZEout		:	 INOUT STD_LOGIC;
		FREEZEin		:	 INOUT STD_LOGIC;
		USB_WAKEUP		:	 INOUT STD_LOGIC
	);
END COMPONENT;

component reco
	PORT
		(
		reconfig_clk		: IN STD_LOGIC ;
		reconfig_fromgxb		: IN STD_LOGIC_VECTOR (67 DOWNTO 0);
		busy		: OUT STD_LOGIC ;
		reconfig_togxb		: OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
	);
end component;

component rx
	PORT
	(
		cal_blk_clk		: IN STD_LOGIC ;
		reconfig_clk		: IN STD_LOGIC ;
		reconfig_togxb		: IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		rx_analogreset		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_cruclk		: IN STD_LOGIC_VECTOR (15 DOWNTO 0) :=  (OTHERS => '0');
		rx_datain		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_digitalreset		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		reconfig_fromgxb		: OUT STD_LOGIC_VECTOR (67 DOWNTO 0);
		rx_byteorderalignstatus		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_clkout		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_ctrldetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_dataout		: OUT STD_LOGIC_VECTOR (255 DOWNTO 0);
		rx_errdetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_freqlocked		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_patterndetect		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rx_pll_locked		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		rx_syncstatus		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
	);
	 
end component;

-- serial wire
signal datainout : std_logic_vector(15 downto 0);

-- signals to reconfig block
signal reconfig_fromgxb_sig		: STD_LOGIC_VECTOR (67 DOWNTO 0);
signal busy_sig : STD_LOGIC;
signal reconfig_togxb_sig : STD_LOGIC_VECTOR (3 DOWNTO 0);

-- rx clock 
signal pll_cru_clk_sig: STD_LOGIC_VECTOR (15 DOWNTO 0); 

-- tmp signals to monitor output
signal rx_dataout_sig : std_logic_vector(255 downto 0);

signal rx_group1 : std_logic_vector(27 downto 0);
signal rx_group2 : std_logic_vector(27 downto 0);
signal rx_group3 : std_logic_vector(27 downto 0);
signal rx_group4 : std_logic_vector(27 downto 0);
signal rx_group5 : std_logic_vector(27 downto 0);
signal rx_group6 : std_logic_vector(27 downto 0);

BEGIN

rx_dataout <= rx_dataout_sig;

rx_group1 <= rx_dataout_sig(27 downto 0);
rx_group2 <= rx_dataout_sig(55 downto 28);
rx_group3 <= rx_dataout_sig(83 downto 56);

rx_group4 <= rx_dataout_sig(155 downto 128);
rx_group5 <= rx_dataout_sig(183 downto 156);
rx_group6 <= rx_dataout_sig(211 downto 184);

label1: for ii in 0 to 15 generate
  pll_cru_clk_sig(ii) <= cal_blk_clk;
end generate;
 
 
-- tx  inst
-- some of the vme interfaces are open
	tx_inst: StratixIV_Tx PORT MAP (
		master_clock0		=>   master_clock0,  -- The_clock of tx
		vme_as		=>   vme_as,
		vme_ds		=>   vme_ds,
		vme_addr		=>   vme_addr,  --[20, 19-18, 17-2: reset_tx, muxsel[1,0], tx_ctrlenable[15,0] 
		vme_write_read	=>   vme_write_read,
		clkin1		=>   tx_pll_inclk_1,
		clkin2		=>   tx_cal_blk_clk_1,
		clkin3		=>   tx_pll_inclk_2,
		clkin4		=>   tx_cal_blk_clk_2,
		USB_CLKOUT		=>   USB_CLKOUT,
		in0			=>   datain0,   -- fifo datain
		in_clk0		=>   in_clk0,   -- fifo wrclk
		in1			=>   datain1,
		in_clk1		=>   in_clk1,
		in2			=>   datain2,
		in_clk2		=>   in_clk2,
		in3			=>   datain3,
		in_clk3		=>   in_clk3,
		in4			=>   datain4,
		in_clk4		=>   in_clk4,
		in5			=>   datain5,
		in_clk5		=>   in_clk5,
		dir_trans		=>   open,
		transceivers_OE	=>   open,
		two_dataout		=>   datainout(15 downto 8), --data out to rx
		one_dataout		=>   datainout(7 downto 0),
		vme_data		=>   open,
		debug			=>   open,
		InternalAUX		=>   open,
		HOLDin			=>   open,
		USB_SPARE		=>   open,
		USB_PA			=>   open,
		USB_CTL			=>   open,
		USB_RDY			=>   open,
		USB_IFCLK		=>   open,
		USB_FD			=>   open,
		HOLDtoEDRO		=>   open,
		LED_1			=>   open,
		LED_2			=>   open,
		LED_3			=>   open,
		FREEZEout		=>   open,
		FREEZEin		=>   open,
		USB_WAKEUP		=>   open
		);

-- reconfig
	reco_inst : reco PORT MAP (
		reconfig_clk	 => reconfig_clk,
		reconfig_fromgxb	 => reconfig_fromgxb_sig,
		busy	 => busy_sig,
		reconfig_togxb	 => reconfig_togxb_sig
	);

-- rx
	rx_inst : rx PORT MAP (
		cal_blk_clk	 => cal_blk_clk,
		rx_cruclk		 => pll_cru_clk_sig,
		reconfig_clk	 => reconfig_clk,
		reconfig_togxb	 => reconfig_togxb_sig,
		rx_analogreset	 => rx_analogreset,
		rx_datain	 => datainout,
		rx_digitalreset	 => rx_digitalreset,
		rx_pll_locked	 => rx_pll_locked,
		reconfig_fromgxb	 => reconfig_fromgxb_sig,
		rx_byteorderalignstatus => rx_byteorderalignstatus,
		rx_clkout	 => rx_clkout,
		rx_ctrldetect	 => rx_ctrldetect,
		rx_dataout	 => rx_dataout_sig,
		rx_errdetect	 => rx_errdetect,
		rx_freqlocked	 => rx_freqlocked,
		rx_patterndetect	 => rx_patterndetect,
		rx_syncstatus	 => rx_syncstatus
	);

END RTL;